/*
 *   Java-Gnome
 *
 *   Copyright (C) 1998 Olivier Gutknecht <gutkneco@lirmm.fr>
 *
 *   The Java-Gnome bindings library is free software distributed under
 *   the terms of the GNU Library General Public License version 2 
 *
 ***********************************************************************/

import java.util.Vector;
import java.util.Enumeration;
import java.io.PrintWriter;

/** Probably buggy as we don't have a way yet to control the base parameter */

public class FlagsDefinition extends EnumDefinition {
    
    public void emit(PrintWriter pw) {
	String name = getName();
	
	StringBuffer sb = new StringBuffer();
	int base = 0;
	Enumeration e = identifiers.elements();
	while (e.hasMoreElements()) {
	    // accumulate the static definitions for after the declaration
	    // of theInterned (can't do that until we know how many
	    // elements there are
	    String s = ((TypeDefinition) e.nextElement()).translateNaming();
	    sb.append("  public final static int _");
	    sb.append(s);
	    sb.append(" = 1 << ");
	    sb.append(base);
	    sb.append(";\n");
	    sb.append("  public final static ");
	    sb.append(name);
	    sb.append(" ");
	    sb.append(s);
	    sb.append(" = ");
	    sb.append(name);
	    sb.append(".intern(1 << ");
	    sb.append(base);
	    sb.append(");\n");

	    base++;
	}

	// output the declaration of theInterned; only output up to 256 entries
	// for space efficiency reasons (sacrificing time efficiency in that
	// hash lookups have to happen for the others)
	if (base >= 8)
	    base = 8;
	int count = 1 << base;
	pw.println("  static private " + name + "[] theInterned = {");
	for (int i = 0; i < count; i++) {
	    if (i != 0)
		pw.print(",\n");
	    pw.print("    new ");
	    pw.print(name);
	    pw.print("(");
	    pw.print(i);
	    pw.print(")");
	}
	pw.println("\n  };");

	// and the rest of the statics
	pw.print(sb.toString());
    }
    
    /*  String enumName;
	Vector identifiers;
    */
    public FlagsDefinition(String p, String n, Vector a) {
	super(p, n, a);
    }
    
    public FlagsDefinition(String n, Vector a) {
	super(n, a);
    }
}
