import gtk.*;
import gnome.*;
import java.util.*;

/**
   Based heavily on TestGTK.java written by Olivier
   
   Not the very best example of good object-oriented Java programming,
   but well, that's not the aim. :-)
   
   @author C.J. van Wyk, Jan 2000

 */

public class TestGNOME
{
    // Some Callbacks
    public boolean delete_event(int dummy)
    {
	Gtk.mainQuit();
	return true;
    };   

    public void destroy()
    {
	Gtk.mainQuit();
    };   

    public void clicked()
    {
	Gtk.mainQuit();	
    };

    public void do_exit()   
    {
	Gtk.mainQuit();
    };

    // Here the fun (and tests) starts
    public void createAbout()
    {
	String title = "My about";
	String version = "Version 0.0.0";
	String license = "GPL";
        String[] authors = {"Me", "Myself", "I"};
	String comments = "My comments";
	String pixmap = "gftp.png";
	GnomeAbout about = new GnomeAbout(title, version, license,
	    authors, comments, pixmap);
	about.show();
}
    
    public void createApp()
    {
	GnomeApp app = new GnomeApp("AppName", "My first App");
	app.show();
    }
    
    public void createAppBar()
    {
	GnomeAppBar app_bar =
	    new GnomeAppBar(true, true, GnomePreferencesType.GNOME_PREFERENCES_USER);
	GnomeApp app = new GnomeApp("AppName", "My first App");
	app.setStatusbar(app_bar);
	app.showAll();
    }
    
    public void createCalculator()
    {
	GnomeCalculator calc = new GnomeCalculator();
        GnomeDialog dial = new GnomeDialog("My first dialog", "OK", null);
	(dial.getvbox()).packStart(calc);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(label);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }
    
    public void createColorSelection()
    {
    }
    
    public void createDateEdit()
    {
	Date now = new Date();
	// GnomeDateEdit
	GtkHBox date_edit_box = new GtkHBox(true, 0);
	GtkLabel date_edit_label = new GtkLabel("Date Edit:");
	GnomeDateEdit date_edit = new GnomeDateEdit(now, 0, 0);
	date_edit_box.packStart(date_edit_label);
	date_edit_box.packStart(date_edit);
	// GnomeDateEdit with time
	GtkHBox time_date_edit_box = new GtkHBox(true, 0);
	GtkLabel time_date_edit_label = new GtkLabel("Date Edit (with time):");
	GnomeDateEdit time_date_edit = new GnomeDateEdit(now, 1, 0);
	time_date_edit_box.packStart(time_date_edit_label);
	time_date_edit_box.packStart(time_date_edit);
	// GnomeDateEdit use 24 hr
	GtkHBox hr_date_edit_box = new GtkHBox(true, 0);
	GtkLabel hr_date_edit_label = new GtkLabel("Date Edit (using 24 hr):");
	GnomeDateEdit hr_date_edit = new GnomeDateEdit(now, 1, 1);
	hr_date_edit_box.packStart(hr_date_edit_label);
	hr_date_edit_box.packStart(hr_date_edit);
	// GtkVBox used to pack everything
	GtkVBox vbox = new GtkVBox(true, 3);
	vbox.packStart(date_edit_box);
	vbox.packStart(time_date_edit_box);
	vbox.packStart(hr_date_edit_box);
	// GnomeDialog and wrapping up
        GnomeDialog dial = new GnomeDialog("DateEdit", "OK", null);
	(dial.getvbox()).packStart(vbox);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(vbox);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }

    public void createDialog()
    {
	GtkLabel label = new GtkLabel("Test to see a dialog in Java-Gnome");
	String[] buttons = {"Ok", "Cancel"};
	GnomeDialog dial = new GnomeDialog("My first dialog", buttons);
        //GnomeDialog dial = new GnomeDialog("My first dialog", "OK", "Cancel",
	//    null);
	(dial.getvbox()).packStart(label);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(label);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }

    public void createEntries()
    {
	// GnomeEntry
	GtkHBox entry_box = new GtkHBox(false, 0);
	GtkLabel entry_label = new GtkLabel("Entry:");
	GnomeEntry entry =
	    new GnomeEntry("Test hist_id");
	entry_box.packStart(entry_label);
	entry_box.packStart(entry);
	// GnomeFileEntry
	GtkHBox file_entry_box = new GtkHBox(false, 0);
	GtkLabel file_entry_label = new GtkLabel("File Entry:");
	GnomeFileEntry file_entry =
	    new GnomeFileEntry("Test (file) hist_id", "FileEntry Test");
	file_entry_box.packStart(file_entry_label);
	file_entry_box.packStart(file_entry);
	// GnomeNumberEntry
	GtkHBox number_entry_box = new GtkHBox(false, 0);
	GtkLabel number_entry_label = new GtkLabel("Number Entry:");
	GnomeNumberEntry number_entry =
	    new GnomeNumberEntry("Test (number) hist_id", "Number Entry Test");
	number_entry_box.packStart(number_entry_label);
	number_entry_box.packStart(number_entry);
	// GnomeIconEntry
	GtkHBox icon_entry_box = new GtkHBox(false, 0);
	GtkLabel icon_entry_label =
	    new GtkLabel("Icon Entry:");
	GnomeIconEntry icon_entry =
	    new GnomeIconEntry("Test (icon) hist_id", "Icon Entry Test");
	icon_entry_box.packStart(icon_entry_label);
	icon_entry_box.packStart(icon_entry);
	// GnomePixmapEntry
	GtkHBox pixmap_entry_box = new GtkHBox(false, 0);
	GtkLabel pixmap_entry_label =
	    new GtkLabel("Pixmap Entry:");
	GnomePixmapEntry pixmap_entry =
	    new GnomePixmapEntry("Test (pixmap) hist_id", "Pixmap Entry Test",
		false);
	pixmap_entry.setPreview(false);
	pixmap_entry.setPreviewSize(40, 40);
	pixmap_entry_box.packStart(pixmap_entry_label);
	pixmap_entry_box.packStart(pixmap_entry);
	// GtkVBox used to pack everything
	GtkVBox vbox = new GtkVBox(false, 3);
	vbox.packStart(entry_box);
	vbox.packStart(file_entry_box);
	vbox.packStart(number_entry_box);
	vbox.packStart(icon_entry_box);
	vbox.packStart(pixmap_entry_box);
	// GnomeDialog and wrapping up
        GnomeDialog dial = new GnomeDialog("Entries", "OK", "Cancel", null);
	(dial.getvbox()).packStart(vbox);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(vbox);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }

    public void createFontSelector()
    {
	GnomeFontSelector font_sel = new GnomeFontSelector();
	font_sel.show();
    }
    
    public void createHRef()
    {
	GnomeHRef href = new GnomeHRef("http://www.redhat.com", "Redhat");
        GnomeDialog dial = new GnomeDialog("GtkHRef", "OK", null);
	(dial.getvbox()).packStart(href);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(label);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }

    public void createUtilDialogs()
    {
        GnomeOkDialog ok =
	    new GnomeOkDialog("This is just for information.");
	ok.show();
        GnomeWarningDialog warning =
	    new GnomeWarningDialog("Warning: This is a Warning!");
	warning.show();
        GnomeErrorDialog error =
	    new GnomeErrorDialog("Error: This is an Error!");
	error.show();
    }

    public void createPickers()
    {
	// GnomeColorPicker
	GtkHBox color_picker_box = new GtkHBox(true, 0);
	GtkLabel color_picker_label = new GtkLabel("Color Picker:");
	GnomeColorPicker color_picker = new GnomeColorPicker();
	color_picker.setD(0.3, 0.2, 0.7, 0.5);
	color_picker_box.packStart(color_picker_label);
	color_picker_box.packStart(color_picker);
	double[] r = {0.5};
	double[] g = {0.5};
	double[] b = {0.5};
	double[] a = {0.5};
	color_picker.getD(r, g, b, a);
	System.out.println("r = "+r[0]+"\ng = "+g[0]+"\nb ="+b[0]+"\na = "+a[0]);
	// GnomeFontPicker
	GtkHBox font_picker_box = new GtkHBox(true, 0);
	GtkLabel font_picker_label = new GtkLabel("Font Picker:");
	GnomeFontPicker font_picker = new GnomeFontPicker();
	font_picker_box.packStart(font_picker_label);
	font_picker_box.packStart(font_picker);
	// GtkVBox used to pack everything
	GtkVBox vbox = new GtkVBox(true, 3);
	vbox.packStart(color_picker_box);
	vbox.packStart(font_picker_box);
	// GnomeDialog and wrapping up
        GnomeDialog dial = new GnomeDialog("Pickers", "OK", null);
	(dial.getvbox()).packStart(vbox);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(vbox);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }

    public void createGtkClock()
    {
	Date now = new Date();
	// GnomeDateEdit (increasing)
	GtkHBox gtk_clock_box = new GtkHBox(true, 0);
	GtkLabel gtk_clock_label = new GtkLabel("Gtk Clock (increasing):");
	GtkClock gtk_clock = new GtkClock(GtkClockType.GTK_CLOCK_INCREASING);
	gtk_clock.start();
	gtk_clock.setUpdateInterval(2);
	gtk_clock_box.packStart(gtk_clock_label);
	gtk_clock_box.packStart(gtk_clock);
	// GnomeDateEdit (decreasing)
	GtkHBox dec_gtk_clock_box = new GtkHBox(true, 0);
	GtkLabel dec_gtk_clock_label = new GtkLabel("Gtk Clock (decreasing):");
	GtkClock dec_gtk_clock = new GtkClock(GtkClockType.GTK_CLOCK_DECREASING);
	dec_gtk_clock.start();
	dec_gtk_clock.setSeconds(now);
	dec_gtk_clock.setUpdateInterval(2);
	dec_gtk_clock_box.packStart(dec_gtk_clock_label);
	dec_gtk_clock_box.packStart(dec_gtk_clock);
	// GnomeDateEdit (realtime)
	GtkHBox rt_gtk_clock_box = new GtkHBox(true, 0);
	GtkLabel rt_gtk_clock_label = new GtkLabel("Gtk Clock (realtime):");
	GtkClock rt_gtk_clock = new GtkClock(GtkClockType.GTK_CLOCK_REALTIME);
	rt_gtk_clock.start();
	rt_gtk_clock_box.packStart(rt_gtk_clock_label);
	rt_gtk_clock_box.packStart(rt_gtk_clock);
	// GtkVBox used to pack everything
	GtkVBox vbox = new GtkVBox(true, 3);
	vbox.packStart(gtk_clock_box);
	vbox.packStart(dec_gtk_clock_box);
	vbox.packStart(rt_gtk_clock_box);
	// GnomeDialog and wrapping up
        GnomeDialog dial = new GnomeDialog("GtkClock", "OK", null);
	(dial.getvbox()).packStart(vbox);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(vbox);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }

    public void createGtkDial()
    {

	GtkAdjustment gtk_adjust = new GtkAdjustment(25, 0, 200, 1, 10, 10);
	GtkDial gtk_dial = new GtkDial(gtk_adjust);
	gtk_dial.setViewOnly(true);
	gtk_dial.setPercentage(0.50);
        GnomeDialog dial = new GnomeDialog("GtkDial", "OK", null);
	(dial.getvbox()).packStart(gtk_dial);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(label);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }

    public void createGtkTed()
    {
	GtkTed gtk_ted = new GtkTed("GtkTed");
	GtkLabel label = new GtkLabel("This will be depreciated!");
	gtk_ted.add(label);
        GnomeDialog dial = new GnomeDialog("GtkDial", "OK", null);
	(dial.getvbox()).packStart(gtk_ted);
	// This is for when (if) we impliment method variables
	//dial.vbox.packStart(label);
	dial.setDefault(0);
	dial.setClose(true);
	dial.showAll();
    }

    public void createMainWindow()
    {
	Hashtable h = new Hashtable();
	// Commented stuff gives problems
	h.put("about", "createAbout");
	h.put("app", "createApp");
	h.put("app bar", "createAppBar");
	h.put("calculator", "createCalculator");
	h.put("canvas", "null"); //"createCanvas");
	h.put("date edit", "createDateEdit");
	h.put("dialog", "createDialog");
	h.put("entries", "createEntries");
	h.put("font selector", "createFontSelector");
	h.put("href", "createHRef");
	h.put("miscellaneous", "null"); //"null");
	h.put("pickers", "createPickers");
	h.put("util dialogs", "createUtilDialogs");
	h.put("gtk clock", "createGtkClock");
	h.put("gtk dial", "createGtkDial");
	h.put("gtk ted", "createGtkTed");

	GtkWindow win = new GtkWindow(GtkWindowType.GTK_WINDOW_TOPLEVEL);
	win.setName("main window");
	win.setUsize(200, 400);
	win.setUposition(20, 20);
	win.signal_connect("destroy", this);
	win.signal_connect("delete_event", this);
	win.setTitle("gtktest");
	GtkVBox box1 = new GtkVBox(false, 0);
	win.add(box1);
	box1.show();
	GtkScrolledWindow scrolledWindow = new GtkScrolledWindow(new GtkAdjustment(),//0,0,0,0,0,0),
	new GtkAdjustment());//0,0,0,0,0,0));
	scrolledWindow.setPolicy(GtkPolicyType.GTK_POLICY_AUTOMATIC, GtkPolicyType.GTK_POLICY_AUTOMATIC);
	scrolledWindow.setBorderWidth(10);
	
	box1.packStart(scrolledWindow, true, true, 0);
	
	scrolledWindow.show();
	GtkVBox box2 = new GtkVBox(false, 0); // Constructors without args fail
	box2.setBorderWidth(10);
	scrolledWindow.addWithViewport(box2);
	box2.show();
	for (Enumeration e = h.keys() ; e.hasMoreElements() ;) 
	    {
		Object key = e.nextElement();
		GtkButton button = new GtkButton((String)key);
		String value = (String) h.get(key); 
		if (value.equals("null"))
		    button.setSensitive(false);
		else
		    button.signal_connect("clicked", (String)value, this);
		box2.packStart(button, true, true, 0);
		button.show();
	    }
	GtkHSeparator separator = new GtkHSeparator();
	box1.packStart(separator, false, true, 0);
	separator.show();
	GtkVBox box3 = new GtkVBox(false, 10);
	box3.setBorderWidth(10);
	box1.packStart(box3, false, true, 0);
	box3.show();
	GtkButton button = new GtkButton("close");
	button.signal_connect("clicked", this);
	//button.setFlags(Gtk.GTK_CAN_DEFAULT);
	box3.packStart(button, true, true, 0);
	//button.grabDefault();
	button.show();
	win.show();
    }

    public TestGNOME()
    {
	createMainWindow();
    }     
   
    public static void main(String[] args)
    {
	Gnome.init("TestGNOME", "0.4.3", 0, 0);
	TestGNOME test = new TestGNOME();
	Gtk.main();
    }
}
